unit MazeVarConst;

interface

uses
    SysUtils, Types, Graphics;

const
      LW      = 12;     //̉ۂ̊{ihbgj

var
    //}bvz̐錾ƒ`
    Lmap: array of array of Byte;
    Dmap: array[0..4, 0..4] of Byte;

    FrontWall: array[0..14] of TRect;
    SideWall : array[0..9, 0..3] of TPoint;

    XMAX, YMAX: integer;

procedure DrawFrontWall(const FrontWall: TRect; var Bitmap: TBitmap);
procedure DrawSideWall(const SideWall: array of TPoint; var Bitmap: TBitmap);

implementation

procedure DrawFrontWall(const FrontWall: TRect; var Bitmap: TBitmap);
begin
    Bitmap.Canvas.Rectangle(FrontWall);
end;

procedure DrawSideWall(const SideWall: array of TPoint; var Bitmap: TBitmap);
begin
    Bitmap.Canvas.Polygon(SideWall);
end;

procedure SetFrontWall;
begin
    FrontWall[ 0] := Rect( 0 * LW, 12 * LW,  6 * LW, 18 * LW);
    FrontWall[ 1] := Rect( 6 * LW, 12 * LW, 12 * LW, 18 * LW);
    FrontWall[ 2] := Rect(12 * LW, 12 * LW, 18 * LW, 18 * LW);
    FrontWall[ 3] := Rect(18 * LW, 12 * LW, 24 * LW, 18 * LW);
    FrontWall[ 4] := Rect(24 * LW, 12 * LW, 30 * LW, 18 * LW);

    FrontWall[ 5] := Rect( 0 * LW, 10 * LW, 10 * LW, 20 * LW);
    FrontWall[ 6] := Rect(10 * LW, 10 * LW, 20 * LW, 20 * LW);
    FrontWall[ 7] := Rect(20 * LW, 10 * LW, 30 * LW, 20 * LW);

    FrontWall[ 8] := Rect( 0 * LW,  7 * LW,  7 * LW, 23 * LW);
    FrontWall[ 9] := Rect( 7 * LW,  7 * LW, 23 * LW, 23 * LW);
    FrontWall[10] := Rect(23 * LW,  7 * LW, 30 * LW, 23 * LW);

    FrontWall[11] := Rect( 0 * LW,  3 * LW,  3 * LW, 27 * LW);
    FrontWall[12] := Rect( 3 * LW,  3 * LW, 27 * LW, 27 * LW);
    FrontWall[13] := Rect(27 * LW,  3 * LW, 30 * LW, 27 * LW);

    FrontWall[14] := Rect( 0 * LW,  0 * LW, 30 * LW, 30 * LW);
end;

procedure SetSideWall;
begin

    SideWall[0, 0] := Point( 0 * LW, 10 * LW);
    SideWall[0, 1] := Point( 6 * LW, 12 * LW);
    SideWall[0, 2] := Point( 6 * LW, 18 * LW);
    SideWall[0, 3] := Point( 0 * LW, 20 * LW);

    SideWall[1, 0] := Point(10 * LW, 10 * LW);
    SideWall[1, 1] := Point(12 * LW, 12 * LW);
    SideWall[1, 2] := Point(12 * LW, 18 * LW);
    SideWall[1, 3] := Point(10 * LW, 20 * LW);

    SideWall[2, 0] := Point(18 * LW, 12 * LW);
    SideWall[2, 1] := Point(20 * LW, 10 * LW);
    SideWall[2, 2] := Point(20 * LW, 20 * LW);
    SideWall[2, 3] := Point(18 * LW, 18 * LW);

    SideWall[3, 0] := Point(24 * LW, 12 * LW);
    SideWall[3, 1] := Point(30 * LW, 10 * LW);
    SideWall[3, 2] := Point(30 * LW, 20 * LW);
    SideWall[3, 3] := Point(24 * LW, 18 * LW);

    SideWall[4, 0] := Point( 7 * LW,  7 * LW);
    SideWall[4, 1] := Point(10 * LW, 10 * LW);
    SideWall[4, 2] := Point(10 * LW, 20 * LW);
    SideWall[4, 3] := Point( 7 * LW, 23 * LW);

    SideWall[5, 0] := Point(20 * LW, 10 * LW);
    SideWall[5, 1] := Point(23 * LW,  7 * LW);
    SideWall[5, 2] := Point(23 * LW, 23 * LW);
    SideWall[5, 3] := Point(20 * LW, 20 * LW);

    SideWall[6, 0] := Point( 3 * LW,  3 * LW);
    SideWall[6, 1] := Point( 7 * LW,  7 * LW);
    SideWall[6, 2] := Point( 7 * LW, 23 * LW);
    SideWall[6, 3] := Point( 3 * LW, 27 * LW);

    SideWall[7, 0] := Point(23 * LW,  7 * LW);
    SideWall[7, 1] := Point(27 * LW,  3 * LW);
    SideWall[7, 2] := Point(27 * LW, 27 * LW);
    SideWall[7, 3] := Point(23 * LW, 23 * LW);

    SideWall[8, 0] := Point( 0 * LW,  0 * LW);
    SideWall[8, 1] := Point( 3 * LW,  3 * LW);
    SideWall[8, 2] := Point( 3 * LW, 27 * LW);
    SideWall[8, 3] := Point( 0 * LW, 30 * LW);

    SideWall[9, 0] := Point(27 * LW,  3 * LW);
    SideWall[9, 1] := Point(30 * LW,  0 * LW);
    SideWall[9, 2] := Point(30 * LW, 30 * LW);
    SideWall[9, 3] := Point(27 * LW, 27 * LW);

end;

initialization
begin
    SetFrontWall;
    SetSideWall;
end;

end.
