unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls, StdCtrls, Buttons, Spin, ComCtrls;

type
  TForm1 = class(TForm)
    Panel5: TPanel;
    BitBtn1: TBitBtn;
    Panel4: TPanel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    DrawGrid1: TDrawGrid;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    Panel3: TPanel;
    StringGrid2: TStringGrid;
    DrawGrid2: TDrawGrid;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure PaintBox1Paint(Sender: TObject);
    procedure DrawGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
    GridBmp: TBitmap;
    FGridPreProc: TWndMethod;
    //C3Dp̃rbg}bv錾
    Back_Bmap: TBitmap;
    procedure Make3D(Mx, My, Md: Byte; var Bmap: TBitmap);
    procedure MovePosition;
    procedure GridWndProc(var Message: TMessage);
    procedure CopyMazeMap;
    procedure CopyDrawMap;
  public
    { Public 錾 }
  end;

var
    Form1: TForm1;
    MazeMap: array of array of Byte;

implementation

uses
    MazeVarConst;

const
      Yoko = 37;   //\鉡p^[
      Tate = 27;   //\cp^[
var
    Dx: array[0..3] of integer = (2, 0, -2, 0);    //  ψʃxNg
    Dy: array[0..3] of integer = (0, 2, 0, -2);    //  ψʃxNg

    DirTable: array[0..23, 0..3] of Byte = (
        (0, 1, 2, 3), (0, 3, 1, 2), (0, 2, 1, 3),
        (0, 2, 3, 1), (0, 3, 1, 2), (0, 3, 2, 1),
        (1, 0, 2, 3), (1, 0, 3, 2), (1, 2, 0, 3),
        (1, 2, 3, 0), (1, 3, 0, 2), (1, 3, 2, 0),
        (2, 0, 1, 3), (2, 0, 3, 1), (2, 1, 0, 3),
        (2, 1, 3, 0), (2, 3, 0, 1), (2, 3, 1, 0),
        (3, 0, 1, 2), (3, 0, 2, 1), (3, 1, 0, 2),
        (3, 1, 2, 0), (3, 2, 0, 1), (3, 2, 0, 0)
    );

    SizeMaxX: integer;
    SizeMaxY: integer;
    WorkMap: array of array of integer;
    SiteX  : array of integer;
    SiteY  : array of integer;
    SiteCount: integer;

    //eϐiByte^CTRect^j̐錾
    LX, LY, Dir: Byte;

{$R *.dfm}

procedure SetMapSize(Col, Row: integer);
begin
    SizeMaxX := Col + 3;
    SizeMaxY := Row + 3;
    SetLength(WorkMap, SizeMaxX + 1, SizeMaxY + 1);
    SetLength(MazeMap, SizeMaxX - 3, SizeMaxY - 3);
    SetLength(SiteX, SizeMaxX * SizeMaxY div 4);
    SetLength(SiteY, SizeMaxX * SizeMaxY div 4);
end;

procedure AddSite(i, j: integer);
begin
    SiteX[SiteCount] := i;
    SiteY[SiteCount] := j;
    Inc(SiteCount);
end;

function SelectSite(var i, j: integer): Boolean;
var
    r: integer;
begin
    Result := not (SiteCount = 0);
    if not Result then Exit;

    Dec(SiteCount);
    r := Round(Random * SiteCount);
    i := SiteX[r];
    j := SiteY[r];
    SiteX[r] := SiteX[SiteCount];
    SiteY[r] := SiteY[SiteCount];
end;

procedure InitMap;
var
    i, j: integer;
begin
    for i := 0 to SizeMaxX do begin
        for j := 0 to SizeMaxY do begin
            WorkMap[i, j] := 1;
        end;
    end;
    for i := 3 to SizeMaxX - 3 do begin
        for j := 3 to SizeMaxY - 3 do begin
            WorkMap[i, j] := 0;
        end;
    end;
    WorkMap[2, 3] := 0;
    WorkMap[SizeMaxX - 2, SizeMaxY - 3] := 0;
end;

procedure InitSite;
var
    i: integer;
begin
    SiteCount := 0;
    for i := 4 to SizeMaxX - 4 do begin
        if Odd(i) then Continue;
        AddSite(i, 2);
        AddSite(i, SizeMaxY - 2);
    end;
    for i := 4 to SizeMaxY - 4 do begin
        if Odd(i) then Continue;
        AddSite(2, i);
        AddSite(SizeMaxX - 2, i);
    end;
end;

procedure SetPracticalMap;
var
    i, j: integer;
begin
    for i := 2 to SizeMaxX - 2 do begin
        for j := 2 to SizeMaxY - 2 do begin
            MazeMap[i - 2, j - 2] := WorkMap[i, j];
        end;
    end;
end;

procedure CreateMazeMap;
var
    i, x, y, t, x1, y1, r, d, memd: integer;
    tt: array[0..3] of integer;
begin
    Randomize;
    InitMap;
    InitSite;

    while SelectSite(x, y) do begin
        while true do begin
            r := Trunc(24 * Random);
            for i := 0 to 3 do begin
                tt[i] := DirTable[r, i];
            end;
            memd := 3;
            for d := 3 downto 0 do begin
                t := tt[d];
                x1 := x + dx[t];
                y1 := y + dy[t];
                if WorkMap[x1, y1] = 0 then Break;
                Dec(memd);
            end;
            if memd < 0 then Break;
            WorkMap[(x + x1) div 2, (y + y1) div 2] := 1;
            x := x1;
            y := y1;
            WorkMap[x, y] := 1;
            AddSite(x, y);
        end;
    end;

    SetPracticalMap;
end;

procedure TForm1.CopyMazeMap;
var
    i, j: integer;
begin
    for i := Low(MazeMap) to High(MazeMap) do begin
        for j := Low(MazeMap[i]) to High(MazeMap[i]) do begin
            StringGrid1.Cells[i, j] := IntToStr(MazeMap[i, j]);
        end;
    end;
    XMAX := SizeMaxX - 3;
    YMAX := SizeMaxY - 3;
    SetLength(LMaP, XMAX, YMAX);
    for i := Low(MazeMap) to High(MazeMap) do begin
        for j := Low(MazeMap[i]) to High(MazeMap[i]) do begin
            LMaP[i, j] := MazeMap[i, j];
        end;
    end;
end;


procedure TForm1.BitBtn1Click(Sender: TObject);
begin
    SpinEdit1.Value := (SpinEdit1.Value div 2) * 2 + 1;
    SpinEdit2.Value := (SpinEdit2.Value div 2) * 2 + 1;

    SetMapSize(SpinEdit2.Value, SpinEdit1.Value);
    CreateMazeMap;

    with StringGrid1 do begin
        RowCount := SpinEdit1.Value;
        ColCount := SpinEdit2.Value;
    end;

    CopyMazeMap;

    with DrawGrid1 do begin
        RowCount := SpinEdit1.Value;
        ColCount := SpinEdit2.Value;
        Repaint;
    end;

    //ϐ̏
    LX  := 3;
    LY  := 3;
    Dir := 1;
    MovePosition;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    FGridPreProc := DrawGrid1.WindowProc;
    DrawGrid1.WindowProc := GridWndProc;
    GridBmp := TBitmap.Create;
    GridBmp.Width  := Screen.Width;
    GridBmp.Height := Screen.Height;

    //C3Dprbg}bvm
    Back_Bmap := TBitmap.Create;
    with Back_Bmap do begin
        Width  := 30 * LW;
        Height := 30 * LW;
        Canvas.Pen.Width   := 2;
        Canvas.Pen.Color   := RGB(204, 204, 204);
        Canvas.Brush.Color := clBlack;
    end;
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];
    
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    GridBmp.Free;
    Back_Bmap.Free;
end;

procedure TForm1.GridWndProc(var Message: TMessage);
begin
  if Message.Msg = WM_ERASEBKGND then Message.Result := 1
                                 else FGridPreProc(Message);
end;



procedure TForm1.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
    aRect: TRect;
    CellValue: Byte;
begin
    aRect := Classes.Rect(0, 0, Rect.Right - Rect.Left, Rect.Bottom - Rect.Top);
    CellValue := StrToIntDef(StringGrid1.Cells[ACol, ARow], 0);
    with GridBmp.Canvas do begin
        case CellValue of
            0:  Brush.Color := clTeal;
            1:  Brush.Color := clBlack;
        end;
        if (ACol = LX) and (ARow = LY) then Brush.Color := clRed;
        FillRect(aRect);
    end;
    BitBlt(
        TDrawGrid(Sender).Canvas.Handle,
        Rect.Left,
        Rect.Top,
        Rect.Right - Rect.Left,
        Rect.Bottom - Rect.Top,
        GridBmp.Canvas.Handle,
        0,
        0,
        SRCCOPY
    );
end;

procedure TForm1.MovePosition;
begin
    //ړ\ȂWύX
    if Dir > 15 then begin
        Dir := Dir and 15;
        case Dir of
            0: if  (LX + 1 <= XMAX)
               and (Lmap[LX + 1, LY] and 1 = 0) then Inc(LX);
            1: if  (LY - 1 >= 0)
               and (Lmap[LX, LY - 1] and 1 = 0) then Dec(LY);
            2: if  (LX - 1 >= 0)
               and (Lmap[LX - 1, LY] and 1 = 0) then Dec(LX);
            3: if  (LY + 1 <= YMAX)
               and (Lmap[LX, LY + 1] and 1 = 0) then Inc(LY);
        end;
    end;
    //̉ĕ\
    Make3D(LX, LY, Dir, Back_Bmap);
    PaintBox1.Refresh;
    DrawGrid1.Refresh;
    CopyDrawMap;
    DrawGrid2.Refresh;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
    with TPaintBox(Sender) do begin
        BitBlt(Canvas.Handle,
               0,     0,
               Width, Height,
               Back_Bmap.Canvas.Handle,
               0,     0,
               SRCCOPY
        )
    end;
end;


procedure TForm1.Make3D(Mx, My, Md: Byte; var Bmap: TBitmap);
var
    X, Y: ShortInt;
    BWidth, BHeight: integer;
begin
  //C3D̑ΏۂƂȂ}bvDmapɍ쐬
    for X := 0 to 4 do for Y:= 0 to 4 do Dmap[X, Y] := 1;

  case Md of
    0: begin
      for X := 4 downto 0 do
        for Y := -2 to 2 do
          if  (Mx + X <= Ymax)
          and (My + Y >= 0)
          and (My + Y <= YMAX)
            then Dmap[Y + 2, 4 - X] := Lmap[Mx + X, My + Y];
    end;
    1: begin
      for Y := -4 to 0 do
        for X := -2 to 2 do
          if  (My + Y >= 0)
          and (Mx + X >= 0)
          and (Mx + X <= Ymax) then
            Dmap[X + 2, Y + 4] := Lmap[Mx + X, My + Y];
    end;
    2: begin
      for X := -4 to 0 do
        for Y := 2 downto -2 do
          if  (Mx + X >= 0)
          and (My + Y >= 0)
          and (My + Y <= XMAX) then
            Dmap[2 - Y, 4 + X] := Lmap[Mx +X , My + Y];
    end;
    3: begin
      for Y := 4 downto 0 do
        for X := 2 downto -2 do
          if  (My + Y <= Ymax)
          and (Mx + X >= 0)
          and (Mx + X <= Ymax) then
            Dmap[2 - X, 4 - Y] := Lmap[Mx + X, My + Y];
    end;
  end;
    //C3Dwrbg}bvɕ`
    BWidth  := Bmap.Width;
    BHeight := Bmap.Height;

    with Bmap.Canvas do begin
        Rectangle(0, 0, BWidth, BHeight);

        //4ubN搳ʕ
        for X := 0 to 4 do
            if (Dmap[X, 0] and 1) = 1 then
                DrawFrontWall(FrontWall[X], Bmap);

        //3ubN扡()
        for X := 0 to 1 do
            if (Dmap[X, 1] and 1) = 1 then
                DrawSideWall(SideWall[X], Bmap);

        //3ubN扡(E)
        for X := 3 to 4 do
            if (Dmap[X, 1] and 1) = 1 then
                DrawSideWall(SideWall[X-1], Bmap);

        //3ubN搳ʕ
        for X := 1 to 3 do
            if (Dmap[X, 1] and 1) = 1 then
                DrawFrontWall(FrontWall[X+4], Bmap);

        //2ubN扡
        if (Dmap[1, 2] and 1) = 1 then
            DrawSideWall(SideWall[4], Bmap);

        if (Dmap[3, 2] and 1) = 1 then
            DrawSideWall(SideWall[5], Bmap);

        //2ubN搳ʕ
        for X := 1 to 3 do
            if (Dmap[X, 2] and 1) = 1 then
                DrawFrontWall(FrontWall[X+7], Bmap);

        //1ubN扡
        if (Dmap[1, 3] and 1) = 1 then
            DrawSideWall(SideWall[6], Bmap);

        if (Dmap[3, 3] and 1) = 1 then
            DrawSideWall(SideWall[7], Bmap);

        //1ubN搳ʕ
        for X := 1 to 3 do
            if (Dmap[X, 3] and 1) = 1 then
                DrawFrontWall(FrontWall[X+10], Bmap);

        //TCh
        if (Dmap[1, 4] and 1) = 1 then
            DrawSideWall(SideWall[8], Bmap);

        if (Dmap[3, 4] and 1) = 1 then
            DrawSideWall(SideWall[9], Bmap);

        //
        FrameRect(FrontWall[14]);

    end;
end;


procedure TForm1.CopyDrawMap;
var
    i, j: integer;
begin
    for i := Low(DMap) to High(DMap) do begin
        for j := Low(DMap[i]) to High(DMap[i]) do begin
            StringGrid2.Cells[i, j] := IntToStr(DMap[i, j]);
        end;
    end;
end;

procedure TForm1.DrawGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
    aRect: TRect;
    CellValue: Byte;
begin
    aRect := Classes.Rect(0, 0, Rect.Right - Rect.Left, Rect.Bottom - Rect.Top);
    CellValue := StrToIntDef(StringGrid2.Cells[ACol, ARow], 0);
    with GridBmp.Canvas do begin
        case CellValue of
            0:  Brush.Color := clTeal;
            1:  Brush.Color := clBlack;
        end;
        FillRect(aRect);
    end;
    BitBlt(
        TDrawGrid(Sender).Canvas.Handle,
        Rect.Left,
        Rect.Top,
        Rect.Right - Rect.Left,
        Rect.Bottom - Rect.Top,
        GridBmp.Canvas.Handle,
        0,
        0,
        SRCCOPY
    );
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key = VK_NUMPAD8 then
    begin
        Dir := Dir or 16;
        MovePosition;
    end else
    if Key = VK_NUMPAD4 then
    begin
        Dir := (Dir + 1) and 3;
        MovePosition;
    end else
    if Key = VK_NUMPAD6 then
    begin
        Dir := (Dir + 3) and 3;
        MovePosition;
    end else
    begin
        ;
    end;

end;

end.
